
const DEBUG: boolean = false;
const INTOOLS: boolean = false;
export function log(msg: string): void {
    if (DEBUG) {
        log4Android(msg);
    } else {

        console.log(msg);
    }
}
export function log4AndroidD(msg: string,tag:string): void {
    let log = "android.util.Log";
    let log_cls = Java.use(log);
    log_cls.d(tag, msg);
}
export function log4AndroidV(msg: string,tag:string): void {
    let log = "android.util.Log";
    let log_cls = Java.use(log);
    log_cls.v(tag, msg);
}
export function log4AndroidI(msg: string,tag:string): void {
    let log = "android.util.Log";
    let log_cls = Java.use(log);
    log_cls.i(tag, msg);
}
export function log4AndroidW(msg: string,tag:string): void {
    let log = "android.util.Log";
    let log_cls = Java.use(log);
    log_cls.w(tag, msg);
}
export function log4AndroidE(msg: string,tag:string): void {
    let log = "android.util.Log";
    let log_cls = Java.use(log);
    log_cls.e(tag, msg);
}
export function log4Android(msg: string): void {
    let log = "android.util.Log";
    let log_cls = Java.use(log);
    log_cls.w("Dumper", msg);
}
export function  logHHex(pointer :NativePointer) :void {
    let s = hexdump(pointer, {
        offset: 0,
        length: 64,
        header: true,
        ansi: true
    });

    console.log(s);
}
export function  logHHexLength(pointer :NativePointer,length: number) :void {
    console.log(hexdump(pointer, {
        offset: 0,
        length: length,
        header: true,
        ansi: true
    }));
}
export function logColor(message: string, type: number): void {

    if (DEBUG) {
        log4Android(message);
        return;
    }
    if (INTOOLS){
        log(message)
        return;
    }
    if (type == undefined) {
        log(message)

        return;
    }
    switch (type) {
        case LogColor.WHITE_TEXT:
        case LogColor.WHITE_BG:
            log(message);
            break;
        case LogColor.RED_TEXT:
        case LogColor.RED_BG:
            console.error(message);
            break;
        case LogColor.YELLOW_TEXT:
        case LogColor.YELLOW_BG:
            console.warn(message);
            break;
        default:
            console.log("\x1b[" + type + "m" + message + "\x1b[0m");
            break;

    }

}

export var LogColor = {
    // STANDARD TEXT COLORS
    BLACK_TEXT: 30,
    RED_TEXT: 31,
    GREEN_TEXT: 32,
    YELLOW_TEXT: 33,
    BLUE_TEXT: 34,
    MAGENTA_TEXT: 35,
    CYAN_TEXT: 36,
    WHITE_TEXT: 37,

    // EXTENDED TEXT COLORS (BRIGHT VERSIONS)
    BRIGHT_BLACK_TEXT: 90,
    BRIGHT_RED_TEXT: 91,
    BRIGHT_GREEN_TEXT: 92,
    BRIGHT_YELLOW_TEXT: 93,
    BRIGHT_BLUE_TEXT: 94,
    BRIGHT_MAGENTA_TEXT: 95,
    BRIGHT_CYAN_TEXT: 96,
    BRIGHT_WHITE_TEXT: 97,

    // STANDARD BACKGROUND COLORS
    BLACK_BG: 40,
    RED_BG: 41,
    GREEN_BG: 42,
    YELLOW_BG: 43,
    BLUE_BG: 44,
    MAGENTA_BG: 45,
    CYAN_BG: 46,
    WHITE_BG: 47,

    // EXTENDED BACKGROUND COLORS (BRIGHT VERSIONS)
    BRIGHT_BLACK_BG: 100,
    BRIGHT_RED_BG: 101,
    BRIGHT_GREEN_BG: 102,
    BRIGHT_YELLOW_BG: 103,
    BRIGHT_BLUE_BG: 104,
    BRIGHT_MAGENTA_BG: 105,
    BRIGHT_CYAN_BG: 106,
    BRIGHT_WHITE_BG: 107
}







